//////////////////////////////////////////////////////////
// GENERATED BY FLUTTIFY. DO NOT EDIT IT.
//////////////////////////////////////////////////////////

#import "MAMapViewFactory.h"
#import "AmapMapFluttifyPlugin.h"

typedef void (^Handler)(NSObject <FlutterPluginRegistrar> *, NSDictionary<NSString *, NSObject *> *, FlutterResult);

@implementation MAMapViewFactory {
  NSObject <FlutterPluginRegistrar> *_registrar;
}

- (instancetype)initWithRegistrar:(NSObject <FlutterPluginRegistrar> *)registrar {
  self = [super init];
  if (self) {
    _registrar = registrar;
  }

  return self;
}

- (NSObject <FlutterPlatformView> *)createWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id _Nullable)args {
  return [[MAMapViewPlatformView alloc] initWithViewId:viewId registrar:_registrar];
}

@end

@implementation MAMapViewPlatformView {
  NSObject <FlutterPluginRegistrar> *_registrar;
  NSInteger _viewId;
  NSDictionary<NSString *, Handler> *_handlerMap;
}

- (instancetype)initWithViewId:(NSInteger)viewId registrar:(NSObject <FlutterPluginRegistrar> *)registrar {
  self = [super init];
  if (self) {
    _viewId = viewId;
    _registrar = registrar;
  }

  return self;
}

- (UIView *)view {
  MAMapView *view = [[MAMapView alloc] init];
  // 这里viewId加1是为了防止往HEAP里放了nil的key, 把HEAP内原先viewId为0的覆盖掉了, 因为nil实际上就是0
  HEAP[@(_viewId + 1)] = view;

  //region handlers
  _handlerMap = @{
      @"MAMapView::setRegionAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* regionValue = (NSValue*) HEAP[@([args[@"region"] integerValue])];
          MACoordinateRegion region;
          [regionValue getValue:&region];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setRegion(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setRegion : region animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::regionThatFits": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* regionValue = (NSValue*) HEAP[@([args[@"region"] integerValue])];
          MACoordinateRegion region;
          [regionValue getValue:&region];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::regionThatFits(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MACoordinateRegion result = [ref regionThatFits: region];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MACoordinateRegion)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::setVisibleMapRectAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* mapRectValue = (NSValue*) HEAP[@([args[@"mapRect"] integerValue])];
          MAMapRect mapRect;
          [mapRectValue getValue:&mapRect];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setVisibleMapRect(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setVisibleMapRect : mapRect animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::mapRectThatFits": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* mapRectValue = (NSValue*) HEAP[@([args[@"mapRect"] integerValue])];
          MAMapRect mapRect;
          [mapRectValue getValue:&mapRect];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::mapRectThatFits(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAMapRect result = [ref mapRectThatFits: mapRect];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MAMapRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::mapRectThatFitsEdgePadding": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* mapRectValue = (NSValue*) HEAP[@([args[@"mapRect"] integerValue])];
          MAMapRect mapRect;
          [mapRectValue getValue:&mapRect];
          // struct arg
          NSValue* insetsValue = (NSValue*) HEAP[@([args[@"insets"] integerValue])];
          UIEdgeInsets insets;
          [insetsValue getValue:&insets];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::mapRectThatFits(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAMapRect result = [ref mapRectThatFits: mapRect edgePadding: insets];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MAMapRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::setVisibleMapRectEdgePaddinganimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* mapRectValue = (NSValue*) HEAP[@([args[@"mapRect"] integerValue])];
          MAMapRect mapRect;
          [mapRectValue getValue:&mapRect];
          // struct arg
          NSValue* insetsValue = (NSValue*) HEAP[@([args[@"insets"] integerValue])];
          UIEdgeInsets insets;
          [insetsValue getValue:&insets];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setVisibleMapRect(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setVisibleMapRect : mapRect edgePadding: insets animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setCenterCoordinateAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* coordinateValue = (NSValue*) HEAP[@([args[@"coordinate"] integerValue])];
          CLLocationCoordinate2D coordinate;
          [coordinateValue getValue:&coordinate];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setCenterCoordinate(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setCenterCoordinate : coordinate animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setZoomLevelAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          CGFloat zoomLevel = [args[@"zoomLevel"] floatValue];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setZoomLevel(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setZoomLevel : zoomLevel animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setZoomLevelAtPivotanimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          CGFloat zoomLevel = [args[@"zoomLevel"] floatValue];
          // struct arg
          NSValue* pivotValue = (NSValue*) HEAP[@([args[@"pivot"] integerValue])];
          CGPoint pivot;
          [pivotValue getValue:&pivot];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setZoomLevel(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setZoomLevel : zoomLevel atPivot: pivot animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setRotationDegreeAnimatedduration": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          CGFloat rotationDegree = [args[@"rotationDegree"] floatValue];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
          // jsonable arg
          CFTimeInterval duration = [args[@"duration"] doubleValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setRotationDegree(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setRotationDegree : rotationDegree animated: animated duration: duration];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setCameraDegreeAnimatedduration": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          CGFloat cameraDegree = [args[@"cameraDegree"] floatValue];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
          // jsonable arg
          CFTimeInterval duration = [args[@"duration"] doubleValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setCameraDegree(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setCameraDegree : cameraDegree animated: animated duration: duration];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::getMapStatus": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::getMapStatus(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAMapStatus* result = [ref getMapStatus];
      
          // result
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      @"MAMapView::setMapStatusAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          MAMapStatus* status = (MAMapStatus*) HEAP[@([args[@"status"] integerValue])];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setMapStatus(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setMapStatus : status animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setMapStatusAnimatedduration": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          MAMapStatus* status = (MAMapStatus*) HEAP[@([args[@"status"] integerValue])];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
          // jsonable arg
          CFTimeInterval duration = [args[@"duration"] doubleValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setMapStatus(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setMapStatus : status animated: animated duration: duration];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setCompassImage": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          UIImage* image = (UIImage*) HEAP[@([args[@"image"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setCompassImage(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setCompassImage : image];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::metersPerPointForZoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          CGFloat zoomLevel = [args[@"zoomLevel"] floatValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::metersPerPointForZoomLevel(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          double result = [ref metersPerPointForZoomLevel: zoomLevel];
      
          // result
          // 返回值: Value
          methodResult(@(result));
      },
      @"MAMapView::convertCoordinateToPointToView": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* coordinateValue = (NSValue*) HEAP[@([args[@"coordinate"] integerValue])];
          CLLocationCoordinate2D coordinate;
          [coordinateValue getValue:&coordinate];
          // ref arg
          UIView* view = (UIView*) HEAP[@([args[@"view"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::convertCoordinate(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          CGPoint result = [ref convertCoordinate: coordinate toPointToView: view];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGPoint)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::convertPointToCoordinateFromView": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* pointValue = (NSValue*) HEAP[@([args[@"point"] integerValue])];
          CGPoint point;
          [pointValue getValue:&point];
          // ref arg
          UIView* view = (UIView*) HEAP[@([args[@"view"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::convertPoint(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          CLLocationCoordinate2D result = [ref convertPoint: point toCoordinateFromView: view];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CLLocationCoordinate2D)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::convertRegionToRectToView": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* regionValue = (NSValue*) HEAP[@([args[@"region"] integerValue])];
          MACoordinateRegion region;
          [regionValue getValue:&region];
          // ref arg
          UIView* view = (UIView*) HEAP[@([args[@"view"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::convertRegion(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          CGRect result = [ref convertRegion: region toRectToView: view];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::convertRectToRegionFromView": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* rectValue = (NSValue*) HEAP[@([args[@"rect"] integerValue])];
          CGRect rect;
          [rectValue getValue:&rect];
          // ref arg
          UIView* view = (UIView*) HEAP[@([args[@"view"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::convertRect(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MACoordinateRegion result = [ref convertRect: rect toRegionFromView: view];
      
          // result
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MACoordinateRegion)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      @"MAMapView::reloadMap": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::reloadMap(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref reloadMap ];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::clearDisk": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::clearDisk(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref clearDisk ];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::reloadInternalTexture": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::reloadInternalTexture(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref reloadInternalTexture ];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::mapContentApprovalNumber": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::mapContentApprovalNumber(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          NSString* result = [ref mapContentApprovalNumber];
      
          // result
          // 返回值: jsonable
          methodResult(result);
      },
      @"MAMapView::satelliteImageApprovalNumber": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::satelliteImageApprovalNumber(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          NSString* result = [ref satelliteImageApprovalNumber];
      
          // result
          // 返回值: jsonable
          methodResult(result);
      },
      @"MAMapView::forceRefresh": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::forceRefresh(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref forceRefresh ];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::addAnnotation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAAnnotation> annotation = (id<MAAnnotation>) HEAP[@([args[@"annotation"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addAnnotation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addAnnotation : annotation];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::addAnnotations": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* annotationsRefArray = (NSArray<NSNumber*> *) args[@"annotations"];
          NSMutableArray<NSArray*>* annotations = [NSMutableArray arrayWithCapacity:annotationsRefArray.count];
          for (int i = 0; i < annotations.count; i++) {
              NSArray* item = (NSArray*) HEAP[[annotationsRefArray objectAtIndex:i]];
              [annotations addObject:item];
          }
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addAnnotations(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addAnnotations : annotations];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::removeAnnotation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAAnnotation> annotation = (id<MAAnnotation>) HEAP[@([args[@"annotation"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::removeAnnotation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref removeAnnotation : annotation];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::removeAnnotations": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* annotationsRefArray = (NSArray<NSNumber*> *) args[@"annotations"];
          NSMutableArray<NSArray*>* annotations = [NSMutableArray arrayWithCapacity:annotationsRefArray.count];
          for (int i = 0; i < annotations.count; i++) {
              NSArray* item = (NSArray*) HEAP[[annotationsRefArray objectAtIndex:i]];
              [annotations addObject:item];
          }
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::removeAnnotations(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref removeAnnotations : annotations];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::viewForAnnotation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAAnnotation> annotation = (id<MAAnnotation>) HEAP[@([args[@"annotation"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::viewForAnnotation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAAnnotationView* result = [ref viewForAnnotation: annotation];
      
          // result
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      @"MAMapView::dequeueReusableAnnotationViewWithIdentifier": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          NSString* identifier = (NSString*) args[@"identifier"];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::dequeueReusableAnnotationViewWithIdentifier(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAAnnotationView* result = [ref dequeueReusableAnnotationViewWithIdentifier: identifier];
      
          // result
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      @"MAMapView::selectAnnotationAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAAnnotation> annotation = (id<MAAnnotation>) HEAP[@([args[@"annotation"] integerValue])];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::selectAnnotation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref selectAnnotation : annotation animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::deselectAnnotationAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAAnnotation> annotation = (id<MAAnnotation>) HEAP[@([args[@"annotation"] integerValue])];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::deselectAnnotation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref deselectAnnotation : annotation animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::showAnnotationsAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* annotationsRefArray = (NSArray<NSNumber*> *) args[@"annotations"];
          NSMutableArray<NSArray*>* annotations = [NSMutableArray arrayWithCapacity:annotationsRefArray.count];
          for (int i = 0; i < annotations.count; i++) {
              NSArray* item = (NSArray*) HEAP[[annotationsRefArray objectAtIndex:i]];
              [annotations addObject:item];
          }
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::showAnnotations(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref showAnnotations : annotations animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::showAnnotationsEdgePaddinganimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* annotationsRefArray = (NSArray<NSNumber*> *) args[@"annotations"];
          NSMutableArray<NSArray*>* annotations = [NSMutableArray arrayWithCapacity:annotationsRefArray.count];
          for (int i = 0; i < annotations.count; i++) {
              NSArray* item = (NSArray*) HEAP[[annotationsRefArray objectAtIndex:i]];
              [annotations addObject:item];
          }
          // struct arg
          NSValue* insetsValue = (NSValue*) HEAP[@([args[@"insets"] integerValue])];
          UIEdgeInsets insets;
          [insetsValue getValue:&insets];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::showAnnotations(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref showAnnotations : annotations edgePadding: insets animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setUserTrackingModeAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // enum arg
          MAUserTrackingMode mode = (MAUserTrackingMode) [args[@"mode"] integerValue];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setUserTrackingMode(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setUserTrackingMode : mode animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::updateUserLocationRepresentation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          MAUserLocationRepresentation* representation = (MAUserLocationRepresentation*) HEAP[@([args[@"representation"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::updateUserLocationRepresentation(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref updateUserLocationRepresentation : representation];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::overlaysInLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // enum arg
          MAOverlayLevel level = (MAOverlayLevel) [args[@"level"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::overlaysInLevel(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          NSArray* result = [ref overlaysInLevel: level];
      
          // result
          // 返回值: 列表
          NSMutableArray* refIdList = [NSMutableArray array];
          for (int i = 0; i < result.count; i++) {
              NSObject* object = [result objectAtIndex:i];
              [refIdList addObject: @(object.hash)];
              HEAP[@([object hash])] = object;
          }
      
          methodResult(refIdList);
      },
      @"MAMapView::addOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addOverlay : overlay];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::addOverlays": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* overlaysRefArray = (NSArray<NSNumber*> *) args[@"overlays"];
          NSMutableArray<NSArray*>* overlays = [NSMutableArray arrayWithCapacity:overlaysRefArray.count];
          for (int i = 0; i < overlays.count; i++) {
              NSArray* item = (NSArray*) HEAP[[overlaysRefArray objectAtIndex:i]];
              [overlays addObject:item];
          }
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addOverlays(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addOverlays : overlays];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::addOverlayLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
          // enum arg
          MAOverlayLevel level = (MAOverlayLevel) [args[@"level"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addOverlay : overlay level: level];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::addOverlaysLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* overlaysRefArray = (NSArray<NSNumber*> *) args[@"overlays"];
          NSMutableArray<NSArray*>* overlays = [NSMutableArray arrayWithCapacity:overlaysRefArray.count];
          for (int i = 0; i < overlays.count; i++) {
              NSArray* item = (NSArray*) HEAP[[overlaysRefArray objectAtIndex:i]];
              [overlays addObject:item];
          }
          // enum arg
          MAOverlayLevel level = (MAOverlayLevel) [args[@"level"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::addOverlays(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref addOverlays : overlays level: level];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::removeOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::removeOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref removeOverlay : overlay];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::removeOverlays": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* overlaysRefArray = (NSArray<NSNumber*> *) args[@"overlays"];
          NSMutableArray<NSArray*>* overlays = [NSMutableArray arrayWithCapacity:overlaysRefArray.count];
          for (int i = 0; i < overlays.count; i++) {
              NSArray* item = (NSArray*) HEAP[[overlaysRefArray objectAtIndex:i]];
              [overlays addObject:item];
          }
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::removeOverlays(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref removeOverlays : overlays];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::insertOverlayAtIndexlevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
          // jsonable arg
          NSUInteger index = [args[@"index"] unsignedIntegerValue];
          // enum arg
          MAOverlayLevel level = (MAOverlayLevel) [args[@"level"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::insertOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref insertOverlay : overlay atIndex: index level: level];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::insertOverlayAboveOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
          // ref arg
          id<MAOverlay> sibling = (id<MAOverlay>) HEAP[@([args[@"sibling"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::insertOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref insertOverlay : overlay aboveOverlay: sibling];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::insertOverlayBelowOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
          // ref arg
          id<MAOverlay> sibling = (id<MAOverlay>) HEAP[@([args[@"sibling"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::insertOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref insertOverlay : overlay belowOverlay: sibling];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::insertOverlayAtIndex": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
          // jsonable arg
          NSUInteger index = [args[@"index"] unsignedIntegerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::insertOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref insertOverlay : overlay atIndex: index];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::exchangeOverlayAtIndexWithOverlayAtIndex": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          NSUInteger index1 = [args[@"index1"] unsignedIntegerValue];
          // jsonable arg
          NSUInteger index2 = [args[@"index2"] unsignedIntegerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::exchangeOverlayAtIndex(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref exchangeOverlayAtIndex : index1 withOverlayAtIndex: index2];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::exchangeOverlayAtIndexWithOverlayAtIndexatLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          NSUInteger index1 = [args[@"index1"] unsignedIntegerValue];
          // jsonable arg
          NSUInteger index2 = [args[@"index2"] unsignedIntegerValue];
          // enum arg
          MAOverlayLevel level = (MAOverlayLevel) [args[@"level"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::exchangeOverlayAtIndex(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref exchangeOverlayAtIndex : index1 withOverlayAtIndex: index2 atLevel: level];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::exchangeOverlayWithOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay1 = (id<MAOverlay>) HEAP[@([args[@"overlay1"] integerValue])];
          // ref arg
          id<MAOverlay> overlay2 = (id<MAOverlay>) HEAP[@([args[@"overlay2"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::exchangeOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref exchangeOverlay : overlay1 withOverlay: overlay2];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::rendererForOverlay": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          id<MAOverlay> overlay = (id<MAOverlay>) HEAP[@([args[@"overlay"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::rendererForOverlay(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          MAOverlayRenderer* result = [ref rendererForOverlay: overlay];
      
          // result
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      @"MAMapView::showOverlaysAnimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* overlaysRefArray = (NSArray<NSNumber*> *) args[@"overlays"];
          NSMutableArray<NSArray*>* overlays = [NSMutableArray arrayWithCapacity:overlaysRefArray.count];
          for (int i = 0; i < overlays.count; i++) {
              NSArray* item = (NSArray*) HEAP[[overlaysRefArray objectAtIndex:i]];
              [overlays addObject:item];
          }
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::showOverlays(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref showOverlays : overlays animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::showOverlaysEdgePaddinganimated": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // list arg
          NSArray<NSNumber*>* overlaysRefArray = (NSArray<NSNumber*> *) args[@"overlays"];
          NSMutableArray<NSArray*>* overlays = [NSMutableArray arrayWithCapacity:overlaysRefArray.count];
          for (int i = 0; i < overlays.count; i++) {
              NSArray* item = (NSArray*) HEAP[[overlaysRefArray objectAtIndex:i]];
              [overlays addObject:item];
          }
          // struct arg
          NSValue* insetsValue = (NSValue*) HEAP[@([args[@"insets"] integerValue])];
          UIEdgeInsets insets;
          [insetsValue getValue:&insets];
          // jsonable arg
          BOOL animated = [args[@"animated"] boolValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::showOverlays(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref showOverlays : overlays edgePadding: insets animated: animated];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setIndoorMapControlOrigin": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // struct arg
          NSValue* originValue = (NSValue*) HEAP[@([args[@"origin"] integerValue])];
          CGPoint origin;
          [originValue getValue:&origin];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setIndoorMapControlOrigin(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setIndoorMapControlOrigin : origin];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setCurrentIndoorMapFloorIndex": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // jsonable arg
          NSInteger floorIndex = [args[@"floorIndex"] integerValue];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setCurrentIndoorMapFloorIndex(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setCurrentIndoorMapFloorIndex : floorIndex];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::clearIndoorMapCache": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
      
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::clearIndoorMapCache(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref clearIndoorMapCache ];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::setCustomMapStyleOptions": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          // args
          // ref arg
          MAMapCustomStyleOptions* styleOptions = (MAMapCustomStyleOptions*) HEAP[@([args[@"styleOptions"] integerValue])];
      
          // ref
          MAMapView* ref = (MAMapView*) HEAP[args[@"refId"]];
      
          // print log
          NSLog(@"fluttify-objc: MAMapView@%@::setCustomMapStyleOptions(暂未实现参数打印)", args[@"refId"]);
      
          // invoke native method
          [ref setCustomMapStyleOptions : styleOptions];
      
          // result
          // 无返回值
          methodResult(@"success");
      },
      @"MAMapView::get_mapType": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_mapType");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MAMapType result = ref.mapType;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_centerCoordinate": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_centerCoordinate");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CLLocationCoordinate2D result = ref.centerCoordinate;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CLLocationCoordinate2D)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_region": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_region");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MACoordinateRegion result = ref.region;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MACoordinateRegion)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_visibleMapRect": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_visibleMapRect");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MAMapRect result = ref.visibleMapRect;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MAMapRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_limitRegion": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_limitRegion");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MACoordinateRegion result = ref.limitRegion;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MACoordinateRegion)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_limitMapRect": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_limitMapRect");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MAMapRect result = ref.limitMapRect;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(MAMapRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_zoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_zoomLevel");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.zoomLevel;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_minZoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_minZoomLevel");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.minZoomLevel;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_maxZoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_maxZoomLevel");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.maxZoomLevel;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_rotationDegree": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_rotationDegree");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.rotationDegree;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_cameraDegree": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_cameraDegree");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.cameraDegree;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_zoomingInPivotsAroundAnchorPoint": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_zoomingInPivotsAroundAnchorPoint");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.zoomingInPivotsAroundAnchorPoint;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isZoomEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isZoomEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.zoomEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isScrollEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isScrollEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.scrollEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isRotateEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isRotateEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.rotateEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isRotateCameraEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isRotateCameraEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.rotateCameraEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isSkyModelEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isSkyModelEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.skyModelEnable;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isShowsBuildings": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isShowsBuildings");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsBuildings;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isShowsLabels": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isShowsLabels");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsLabels;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isShowTraffic": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isShowTraffic");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showTraffic;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_trafficRatio": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_trafficRatio");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGFloat result = ref.trafficRatio;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_touchPOIEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_touchPOIEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.touchPOIEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_showsCompass": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_showsCompass");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsCompass;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_compassOrigin": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_compassOrigin");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGPoint result = ref.compassOrigin;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGPoint)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_compassSize": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_compassSize");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGSize result = ref.compassSize;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGSize)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_showsScale": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_showsScale");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsScale;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_scaleOrigin": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_scaleOrigin");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGPoint result = ref.scaleOrigin;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGPoint)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_scaleSize": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_scaleSize");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGSize result = ref.scaleSize;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGSize)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_logoCenter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_logoCenter");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGPoint result = ref.logoCenter;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGPoint)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_logoSize": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_logoSize");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGSize result = ref.logoSize;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGSize)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_metersPerPointForCurrentZoom": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_metersPerPointForCurrentZoom");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          double result = ref.metersPerPointForCurrentZoom;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isAbroad": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isAbroad");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.isAbroad;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_maxRenderFrame": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_maxRenderFrame");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          NSUInteger result = ref.maxRenderFrame;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isAllowDecreaseFrame": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isAllowDecreaseFrame");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.isAllowDecreaseFrame;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_openGLESDisabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_openGLESDisabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.openGLESDisabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_screenAnchor": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_screenAnchor");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGPoint result = ref.screenAnchor;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGPoint)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_annotations": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_annotations");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          NSArray* result = ref.annotations;
      
          // 返回值: 列表
          NSMutableArray* refIdList = [NSMutableArray array];
          for (int i = 0; i < result.count; i++) {
              NSObject* object = [result objectAtIndex:i];
              [refIdList addObject: @(object.hash)];
              HEAP[@([object hash])] = object;
          }
      
          methodResult(refIdList);
      },
      
      @"MAMapView::get_selectedAnnotations": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_selectedAnnotations");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          NSArray* result = ref.selectedAnnotations;
      
          // 返回值: 列表
          NSMutableArray* refIdList = [NSMutableArray array];
          for (int i = 0; i < result.count; i++) {
              NSObject* object = [result objectAtIndex:i];
              [refIdList addObject: @(object.hash)];
              HEAP[@([object hash])] = object;
          }
      
          methodResult(refIdList);
      },
      
      @"MAMapView::get_annotationVisibleRect": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_annotationVisibleRect");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGRect result = ref.annotationVisibleRect;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGRect)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_allowsAnnotationViewSorting": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_allowsAnnotationViewSorting");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.allowsAnnotationViewSorting;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_showsUserLocation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_showsUserLocation");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsUserLocation;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_userLocation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_userLocation");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MAUserLocation* result = ref.userLocation;
      
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      
      @"MAMapView::get_customizeUserLocationAccuracyCircleRepresentation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_customizeUserLocationAccuracyCircleRepresentation");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.customizeUserLocationAccuracyCircleRepresentation;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_userLocationAccuracyCircle": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_userLocationAccuracyCircle");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MACircle* result = ref.userLocationAccuracyCircle;
      
          // 返回值: 引用
          HEAP[@(result.hash)] = result;
          methodResult(@(result.hash));
      },
      
      @"MAMapView::get_userTrackingMode": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_userTrackingMode");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          MAUserTrackingMode result = ref.userTrackingMode;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isUserLocationVisible": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isUserLocationVisible");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.userLocationVisible;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_distanceFilter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_distanceFilter");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CLLocationDistance result = ref.distanceFilter;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_desiredAccuracy": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_desiredAccuracy");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CLLocationAccuracy result = ref.desiredAccuracy;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_headingFilter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_headingFilter");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CLLocationDegrees result = ref.headingFilter;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_pausesLocationUpdatesAutomatically": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_pausesLocationUpdatesAutomatically");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.pausesLocationUpdatesAutomatically;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_allowsBackgroundLocationUpdates": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_allowsBackgroundLocationUpdates");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.allowsBackgroundLocationUpdates;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_overlays": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_overlays");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          NSArray* result = ref.overlays;
      
          // 返回值: 列表
          NSMutableArray* refIdList = [NSMutableArray array];
          for (int i = 0; i < result.count; i++) {
              NSObject* object = [result objectAtIndex:i];
              [refIdList addObject: @(object.hash)];
              HEAP[@([object hash])] = object;
          }
      
          methodResult(refIdList);
      },
      
      @"MAMapView::get_isShowsIndoorMap": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isShowsIndoorMap");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsIndoorMap;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_isShowsIndoorMapControl": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_isShowsIndoorMapControl");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.showsIndoorMapControl;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::get_indoorMapControlSize": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_indoorMapControlSize");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          CGSize result = ref.indoorMapControlSize;
      
          // 返回值: 结构体
          NSValue* resultValue = [NSValue value:&result withObjCType:@encode(CGSize)];
          HEAP[@(resultValue.hash)] = resultValue;
      
          methodResult(@(resultValue.hash));
      },
      
      @"MAMapView::get_customMapStyleEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::get_customMapStyleEnabled");
      
          // ref object
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          // invoke native method
          BOOL result = ref.customMapStyleEnabled;
      
          // 返回值: Value
          methodResult(@(result));
      },
      
      @"MAMapView::set_delegate": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_delegate");
      
          // args
      
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.delegate = self;
          methodResult(@"success");
      },
      
      @"MAMapView::set_mapType": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_mapType");
      
          // args
          // enum arg
          MAMapType mapType = (MAMapType) [args[@"mapType"] integerValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.mapType = mapType;
          methodResult(@"success");
      },
      
      @"MAMapView::set_centerCoordinate": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_centerCoordinate");
      
          // args
          // struct arg
          NSValue* centerCoordinateValue = (NSValue*) HEAP[@([args[@"centerCoordinate"] integerValue])];
          CLLocationCoordinate2D centerCoordinate;
          [centerCoordinateValue getValue:&centerCoordinate];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.centerCoordinate = centerCoordinate;
          methodResult(@"success");
      },
      
      @"MAMapView::set_region": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_region");
      
          // args
          // struct arg
          NSValue* regionValue = (NSValue*) HEAP[@([args[@"region"] integerValue])];
          MACoordinateRegion region;
          [regionValue getValue:&region];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.region = region;
          methodResult(@"success");
      },
      
      @"MAMapView::set_visibleMapRect": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_visibleMapRect");
      
          // args
          // struct arg
          NSValue* visibleMapRectValue = (NSValue*) HEAP[@([args[@"visibleMapRect"] integerValue])];
          MAMapRect visibleMapRect;
          [visibleMapRectValue getValue:&visibleMapRect];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.visibleMapRect = visibleMapRect;
          methodResult(@"success");
      },
      
      @"MAMapView::set_limitRegion": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_limitRegion");
      
          // args
          // struct arg
          NSValue* limitRegionValue = (NSValue*) HEAP[@([args[@"limitRegion"] integerValue])];
          MACoordinateRegion limitRegion;
          [limitRegionValue getValue:&limitRegion];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.limitRegion = limitRegion;
          methodResult(@"success");
      },
      
      @"MAMapView::set_limitMapRect": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_limitMapRect");
      
          // args
          // struct arg
          NSValue* limitMapRectValue = (NSValue*) HEAP[@([args[@"limitMapRect"] integerValue])];
          MAMapRect limitMapRect;
          [limitMapRectValue getValue:&limitMapRect];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.limitMapRect = limitMapRect;
          methodResult(@"success");
      },
      
      @"MAMapView::set_zoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_zoomLevel");
      
          // args
          // jsonable arg
          CGFloat zoomLevel = [args[@"zoomLevel"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.zoomLevel = zoomLevel;
          methodResult(@"success");
      },
      
      @"MAMapView::set_minZoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_minZoomLevel");
      
          // args
          // jsonable arg
          CGFloat minZoomLevel = [args[@"minZoomLevel"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.minZoomLevel = minZoomLevel;
          methodResult(@"success");
      },
      
      @"MAMapView::set_maxZoomLevel": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_maxZoomLevel");
      
          // args
          // jsonable arg
          CGFloat maxZoomLevel = [args[@"maxZoomLevel"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.maxZoomLevel = maxZoomLevel;
          methodResult(@"success");
      },
      
      @"MAMapView::set_rotationDegree": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_rotationDegree");
      
          // args
          // jsonable arg
          CGFloat rotationDegree = [args[@"rotationDegree"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.rotationDegree = rotationDegree;
          methodResult(@"success");
      },
      
      @"MAMapView::set_cameraDegree": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_cameraDegree");
      
          // args
          // jsonable arg
          CGFloat cameraDegree = [args[@"cameraDegree"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.cameraDegree = cameraDegree;
          methodResult(@"success");
      },
      
      @"MAMapView::set_zoomingInPivotsAroundAnchorPoint": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_zoomingInPivotsAroundAnchorPoint");
      
          // args
          // jsonable arg
          BOOL zoomingInPivotsAroundAnchorPoint = [args[@"zoomingInPivotsAroundAnchorPoint"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.zoomingInPivotsAroundAnchorPoint = zoomingInPivotsAroundAnchorPoint;
          methodResult(@"success");
      },
      
      @"MAMapView::set_zoomEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_zoomEnabled");
      
          // args
          // jsonable arg
          BOOL zoomEnabled = [args[@"zoomEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.zoomEnabled = zoomEnabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_scrollEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_scrollEnabled");
      
          // args
          // jsonable arg
          BOOL scrollEnabled = [args[@"scrollEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.scrollEnabled = scrollEnabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_rotateEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_rotateEnabled");
      
          // args
          // jsonable arg
          BOOL rotateEnabled = [args[@"rotateEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.rotateEnabled = rotateEnabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_rotateCameraEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_rotateCameraEnabled");
      
          // args
          // jsonable arg
          BOOL rotateCameraEnabled = [args[@"rotateCameraEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.rotateCameraEnabled = rotateCameraEnabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_skyModelEnable": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_skyModelEnable");
      
          // args
          // jsonable arg
          BOOL skyModelEnable = [args[@"skyModelEnable"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.skyModelEnable = skyModelEnable;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsBuildings": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsBuildings");
      
          // args
          // jsonable arg
          BOOL showsBuildings = [args[@"showsBuildings"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsBuildings = showsBuildings;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsLabels": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsLabels");
      
          // args
          // jsonable arg
          BOOL showsLabels = [args[@"showsLabels"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsLabels = showsLabels;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showTraffic": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showTraffic");
      
          // args
          // jsonable arg
          BOOL showTraffic = [args[@"showTraffic"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showTraffic = showTraffic;
          methodResult(@"success");
      },
      
      @"MAMapView::set_trafficRatio": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_trafficRatio");
      
          // args
          // jsonable arg
          CGFloat trafficRatio = [args[@"trafficRatio"] floatValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.trafficRatio = trafficRatio;
          methodResult(@"success");
      },
      
      @"MAMapView::set_touchPOIEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_touchPOIEnabled");
      
          // args
          // jsonable arg
          BOOL touchPOIEnabled = [args[@"touchPOIEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.touchPOIEnabled = touchPOIEnabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsCompass": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsCompass");
      
          // args
          // jsonable arg
          BOOL showsCompass = [args[@"showsCompass"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsCompass = showsCompass;
          methodResult(@"success");
      },
      
      @"MAMapView::set_compassOrigin": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_compassOrigin");
      
          // args
          // struct arg
          NSValue* compassOriginValue = (NSValue*) HEAP[@([args[@"compassOrigin"] integerValue])];
          CGPoint compassOrigin;
          [compassOriginValue getValue:&compassOrigin];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.compassOrigin = compassOrigin;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsScale": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsScale");
      
          // args
          // jsonable arg
          BOOL showsScale = [args[@"showsScale"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsScale = showsScale;
          methodResult(@"success");
      },
      
      @"MAMapView::set_scaleOrigin": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_scaleOrigin");
      
          // args
          // struct arg
          NSValue* scaleOriginValue = (NSValue*) HEAP[@([args[@"scaleOrigin"] integerValue])];
          CGPoint scaleOrigin;
          [scaleOriginValue getValue:&scaleOrigin];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.scaleOrigin = scaleOrigin;
          methodResult(@"success");
      },
      
      @"MAMapView::set_logoCenter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_logoCenter");
      
          // args
          // struct arg
          NSValue* logoCenterValue = (NSValue*) HEAP[@([args[@"logoCenter"] integerValue])];
          CGPoint logoCenter;
          [logoCenterValue getValue:&logoCenter];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.logoCenter = logoCenter;
          methodResult(@"success");
      },
      
      @"MAMapView::set_maxRenderFrame": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_maxRenderFrame");
      
          // args
          // jsonable arg
          NSUInteger maxRenderFrame = [args[@"maxRenderFrame"] unsignedIntegerValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.maxRenderFrame = maxRenderFrame;
          methodResult(@"success");
      },
      
      @"MAMapView::set_isAllowDecreaseFrame": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_isAllowDecreaseFrame");
      
          // args
          // jsonable arg
          BOOL isAllowDecreaseFrame = [args[@"isAllowDecreaseFrame"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.isAllowDecreaseFrame = isAllowDecreaseFrame;
          methodResult(@"success");
      },
      
      @"MAMapView::set_openGLESDisabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_openGLESDisabled");
      
          // args
          // jsonable arg
          BOOL openGLESDisabled = [args[@"openGLESDisabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.openGLESDisabled = openGLESDisabled;
          methodResult(@"success");
      },
      
      @"MAMapView::set_screenAnchor": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_screenAnchor");
      
          // args
          // struct arg
          NSValue* screenAnchorValue = (NSValue*) HEAP[@([args[@"screenAnchor"] integerValue])];
          CGPoint screenAnchor;
          [screenAnchorValue getValue:&screenAnchor];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.screenAnchor = screenAnchor;
          methodResult(@"success");
      },
      
      @"MAMapView::set_selectedAnnotations": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_selectedAnnotations");
      
          // args
          // list arg
          NSArray<NSNumber*>* selectedAnnotationsRefArray = (NSArray<NSNumber*> *) args[@"selectedAnnotations"];
          NSMutableArray<NSArray*>* selectedAnnotations = [NSMutableArray arrayWithCapacity:selectedAnnotationsRefArray.count];
          for (int i = 0; i < selectedAnnotations.count; i++) {
              NSArray* item = (NSArray*) HEAP[[selectedAnnotationsRefArray objectAtIndex:i]];
              [selectedAnnotations addObject:item];
          }
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.selectedAnnotations = selectedAnnotations;
          methodResult(@"success");
      },
      
      @"MAMapView::set_allowsAnnotationViewSorting": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_allowsAnnotationViewSorting");
      
          // args
          // jsonable arg
          BOOL allowsAnnotationViewSorting = [args[@"allowsAnnotationViewSorting"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.allowsAnnotationViewSorting = allowsAnnotationViewSorting;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsUserLocation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsUserLocation");
      
          // args
          // jsonable arg
          BOOL showsUserLocation = [args[@"showsUserLocation"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsUserLocation = showsUserLocation;
          methodResult(@"success");
      },
      
      @"MAMapView::set_customizeUserLocationAccuracyCircleRepresentation": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_customizeUserLocationAccuracyCircleRepresentation");
      
          // args
          // jsonable arg
          BOOL customizeUserLocationAccuracyCircleRepresentation = [args[@"customizeUserLocationAccuracyCircleRepresentation"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.customizeUserLocationAccuracyCircleRepresentation = customizeUserLocationAccuracyCircleRepresentation;
          methodResult(@"success");
      },
      
      @"MAMapView::set_userTrackingMode": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_userTrackingMode");
      
          // args
          // enum arg
          MAUserTrackingMode userTrackingMode = (MAUserTrackingMode) [args[@"userTrackingMode"] integerValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.userTrackingMode = userTrackingMode;
          methodResult(@"success");
      },
      
      @"MAMapView::set_distanceFilter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_distanceFilter");
      
          // args
          // jsonable arg
          CLLocationDistance distanceFilter = [args[@"distanceFilter"] doubleValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.distanceFilter = distanceFilter;
          methodResult(@"success");
      },
      
      @"MAMapView::set_desiredAccuracy": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_desiredAccuracy");
      
          // args
          // jsonable arg
          CLLocationAccuracy desiredAccuracy = [args[@"desiredAccuracy"] doubleValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.desiredAccuracy = desiredAccuracy;
          methodResult(@"success");
      },
      
      @"MAMapView::set_headingFilter": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_headingFilter");
      
          // args
          // jsonable arg
          CLLocationDegrees headingFilter = [args[@"headingFilter"] doubleValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.headingFilter = headingFilter;
          methodResult(@"success");
      },
      
      @"MAMapView::set_pausesLocationUpdatesAutomatically": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_pausesLocationUpdatesAutomatically");
      
          // args
          // jsonable arg
          BOOL pausesLocationUpdatesAutomatically = [args[@"pausesLocationUpdatesAutomatically"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.pausesLocationUpdatesAutomatically = pausesLocationUpdatesAutomatically;
          methodResult(@"success");
      },
      
      @"MAMapView::set_allowsBackgroundLocationUpdates": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_allowsBackgroundLocationUpdates");
      
          // args
          // jsonable arg
          BOOL allowsBackgroundLocationUpdates = [args[@"allowsBackgroundLocationUpdates"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.allowsBackgroundLocationUpdates = allowsBackgroundLocationUpdates;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsIndoorMap": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsIndoorMap");
      
          // args
          // jsonable arg
          BOOL showsIndoorMap = [args[@"showsIndoorMap"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsIndoorMap = showsIndoorMap;
          methodResult(@"success");
      },
      
      @"MAMapView::set_showsIndoorMapControl": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_showsIndoorMapControl");
      
          // args
          // jsonable arg
          BOOL showsIndoorMapControl = [args[@"showsIndoorMapControl"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.showsIndoorMapControl = showsIndoorMapControl;
          methodResult(@"success");
      },
      
      @"MAMapView::set_customMapStyleEnabled": ^(NSObject <FlutterPluginRegistrar> * registrar, NSDictionary<NSString *, id> * args, FlutterResult methodResult) {
          NSLog(@"MAMapView::set_customMapStyleEnabled");
      
          // args
          // jsonable arg
          BOOL customMapStyleEnabled = [args[@"customMapStyleEnabled"] boolValue];
      
          NSInteger refId = [args[@"refId"] integerValue];
          MAMapView* ref = (MAMapView*) HEAP[@(refId)];
      
          ref.customMapStyleEnabled = customMapStyleEnabled;
          methodResult(@"success");
      },
      
  };
  //endregion

  //region method call handler
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"me.yohom/amap_map_fluttify/MAMapView"
            binaryMessenger:[_registrar messenger]];

  __weak __typeof(self)weakSelf = self;
  [channel setMethodCallHandler:^(FlutterMethodCall *methodCall, FlutterResult methodResult) {
    NSDictionary<NSString *, id> *args = (NSDictionary<NSString *, id> *) [methodCall arguments];

    __strong __typeof(weakSelf)strongSelf = weakSelf;
    if (strongSelf->_handlerMap[methodCall.method] != nil) {
      strongSelf->_handlerMap[methodCall.method](strongSelf->_registrar, args, methodResult);
    } else {
      methodResult(FlutterMethodNotImplemented);
    }
  }];
  //endregion
  return view;
}

//region delegate
- (void)traceManager : (MATraceManager*)manager didTrace: (NSArray<CLLocation*>*)locations correct: (NSArray<MATracePoint*>*)tracePoints distance: (double)distance withError: (NSError*)error
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MATraceDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MATraceDelegate::traceManagerDidTracecorrectdistancewithError");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmanager = @(manager.hash);
  HEAP[argmanager] = manager;
  // list callback arg
  NSMutableArray<NSNumber*>* arglocations = [NSMutableArray arrayWithCapacity:locations.count];
  for (int i = 0; i < locations.count; i++) {
      NSObject* item = ((NSObject*) [locations objectAtIndex:i]);
      // return to dart side data
      arglocations[i] = @(item.hash);
      // add to HEAP
      HEAP[@(item.hash)] = item;
  }
  // list callback arg
  NSMutableArray<NSNumber*>* argtracePoints = [NSMutableArray arrayWithCapacity:tracePoints.count];
  for (int i = 0; i < tracePoints.count; i++) {
      NSObject* item = ((NSObject*) [tracePoints objectAtIndex:i]);
      // return to dart side data
      argtracePoints[i] = @(item.hash);
      // add to HEAP
      HEAP[@(item.hash)] = item;
  }
  // primitive callback arg
  NSNumber* argdistance = @(distance);
  // ref callback arg
  NSNumber* argerror = @(error.hash);
  HEAP[argerror] = error;

  [channel invokeMethod:@"Callback::MATraceDelegate::traceManagerDidTracecorrectdistancewithError" arguments:@{@"manager": argmanager, @"locations": arglocations, @"tracePoints": argtracePoints, @"distance": argdistance, @"error": argerror}];
  
}

- (void)mapViewRequireLocationAuth : (CLLocationManager*)locationManager
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MATraceDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MATraceDelegate::mapViewRequireLocationAuth");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* arglocationManager = @(locationManager.hash);
  HEAP[arglocationManager] = locationManager;

  [channel invokeMethod:@"Callback::MATraceDelegate::mapViewRequireLocationAuth" arguments:@{@"locationManager": arglocationManager}];
  
}

- (void)multiPointOverlayRenderer : (MAMultiPointOverlayRenderer*)renderer didItemTapped: (MAMultiPointItem*)item
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMultiPointOverlayRendererDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMultiPointOverlayRendererDelegate::multiPointOverlayRendererDidItemTapped");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argrenderer = @(renderer.hash);
  HEAP[argrenderer] = renderer;
  // ref callback arg
  NSNumber* argitem = @(item.hash);
  HEAP[argitem] = item;

  [channel invokeMethod:@"Callback::MAMultiPointOverlayRendererDelegate::multiPointOverlayRendererDidItemTapped" arguments:@{@"renderer": argrenderer, @"item": argitem}];
  
}

- (void)mapViewRegionChanged : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewRegionChanged");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewRegionChanged" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapView : (MAMapView*)mapView regionWillChangeAnimated: (BOOL)animated
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewRegionWillChangeAnimated");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* arganimated = @(animated);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewRegionWillChangeAnimated" arguments:@{@"mapView": argmapView, @"animated": arganimated}];
  
}

- (void)mapView : (MAMapView*)mapView regionDidChangeAnimated: (BOOL)animated
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewRegionDidChangeAnimated");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* arganimated = @(animated);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewRegionDidChangeAnimated" arguments:@{@"mapView": argmapView, @"animated": arganimated}];
  
}

- (void)mapView : (MAMapView*)mapView mapWillMoveByUser: (BOOL)wasUserAction
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewMapWillMoveByUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* argwasUserAction = @(wasUserAction);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewMapWillMoveByUser" arguments:@{@"mapView": argmapView, @"wasUserAction": argwasUserAction}];
  
}

- (void)mapView : (MAMapView*)mapView mapDidMoveByUser: (BOOL)wasUserAction
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewMapDidMoveByUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* argwasUserAction = @(wasUserAction);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewMapDidMoveByUser" arguments:@{@"mapView": argmapView, @"wasUserAction": argwasUserAction}];
  
}

- (void)mapView : (MAMapView*)mapView mapWillZoomByUser: (BOOL)wasUserAction
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewMapWillZoomByUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* argwasUserAction = @(wasUserAction);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewMapWillZoomByUser" arguments:@{@"mapView": argmapView, @"wasUserAction": argwasUserAction}];
  
}

- (void)mapView : (MAMapView*)mapView mapDidZoomByUser: (BOOL)wasUserAction
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewMapDidZoomByUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* argwasUserAction = @(wasUserAction);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewMapDidZoomByUser" arguments:@{@"mapView": argmapView, @"wasUserAction": argwasUserAction}];
  
}

- (void)mapViewWillStartLoadingMap : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewWillStartLoadingMap");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewWillStartLoadingMap" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapViewDidFinishLoadingMap : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidFinishLoadingMap");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidFinishLoadingMap" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapViewDidFailLoadingMap : (MAMapView*)mapView withError: (NSError*)error
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidFailLoadingMapWithError");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argerror = @(error.hash);
  HEAP[argerror] = error;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidFailLoadingMapWithError" arguments:@{@"mapView": argmapView, @"error": argerror}];
  
}

- (MAAnnotationView*)mapView : (MAMapView*)mapView viewForAnnotation: (id<MAAnnotation>)annotation
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewViewForAnnotation");

  // convert to jsonable arg
  

  // __block #__callback_result_type__# _callbackResult = nil;
  // [channel invokeMethod:@"#__callback_method__#"
  //             arguments:@{#__callback_args__#}
  //                result:^(id result) {
  //                  #__raw_callback_result__#
  //                }];
  //
  // while (_callbackResult == nil) {
  //   // _callbackResult有值前, 空转
  // }
  //
  // #__struct_value__#
  //
  // return #__callback_result__#;
  
  // 由于flutter无法同步调用method channel, 所以暂不支持有返回值的回调方法
  // 相关issue https://github.com/flutter/flutter/issues/28310
  NSLog(@"暂不支持有返回值的回调方法");
  
  ////////////////////////////如果需要手写代码, 请写在这里/////////////////////////////
  UIImage* icon = (UIImage*) STACK[@"icon"];
  NSNumber* draggable = (NSNumber*) STACK[@"draggable"];
  if ([annotation isKindOfClass:[MAPointAnnotation class]])
  {
      static NSString *pointReuseIndentifier = @"pointReuseIndentifier";
      MAPinAnnotationView*annotationView = (MAPinAnnotationView*)[mapView dequeueReusableAnnotationViewWithIdentifier:pointReuseIndentifier];
      if (annotationView == nil)
      {
          annotationView = [[MAPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:pointReuseIndentifier];
      }
      annotationView.image = icon;
      annotationView.draggable = [draggable boolValue];
      annotationView.canShowCallout = YES; // 这个参数在android端没有配置, 默认就是可以显示弹窗

      // 这次调用完成后 清空栈
      [STACK removeAllObjects];
      return annotationView;
  }
  ////////////////////////////////////////////////////////////////////////////////
  
  return nil;
}

- (void)mapView : (MAMapView*)mapView didAddAnnotationViews: (NSArray*)views
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidAddAnnotationViews");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // list callback arg
  NSMutableArray<NSNumber*>* argviews = [NSMutableArray arrayWithCapacity:views.count];
  for (int i = 0; i < views.count; i++) {
      NSObject* item = ((NSObject*) [views objectAtIndex:i]);
      // return to dart side data
      argviews[i] = @(item.hash);
      // add to HEAP
      HEAP[@(item.hash)] = item;
  }

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidAddAnnotationViews" arguments:@{@"mapView": argmapView, @"views": argviews}];
  
}

- (void)mapView : (MAMapView*)mapView didSelectAnnotationView: (MAAnnotationView*)view
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidSelectAnnotationView");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidSelectAnnotationView" arguments:@{@"mapView": argmapView, @"view": argview}];
  
}

- (void)mapView : (MAMapView*)mapView didDeselectAnnotationView: (MAAnnotationView*)view
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidDeselectAnnotationView");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidDeselectAnnotationView" arguments:@{@"mapView": argmapView, @"view": argview}];
  
}

- (void)mapViewWillStartLocatingUser : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewWillStartLocatingUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewWillStartLocatingUser" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapViewDidStopLocatingUser : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidStopLocatingUser");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidStopLocatingUser" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapView : (MAMapView*)mapView didUpdateUserLocation: (MAUserLocation*)userLocation updatingLocation: (BOOL)updatingLocation
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidUpdateUserLocationupdatingLocation");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* arguserLocation = @(userLocation.hash);
  HEAP[arguserLocation] = userLocation;
  // primitive callback arg
  NSNumber* argupdatingLocation = @(updatingLocation);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidUpdateUserLocationupdatingLocation" arguments:@{@"mapView": argmapView, @"userLocation": arguserLocation, @"updatingLocation": argupdatingLocation}];
  
}

- (void)mapView : (MAMapView*)mapView didFailToLocateUserWithError: (NSError*)error
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidFailToLocateUserWithError");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argerror = @(error.hash);
  HEAP[argerror] = error;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidFailToLocateUserWithError" arguments:@{@"mapView": argmapView, @"error": argerror}];
  
}

- (void)mapView : (MAMapView*)mapView annotationView: (MAAnnotationView*)view didChangeDragState: (MAAnnotationViewDragState)newState fromOldState: (MAAnnotationViewDragState)oldState
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewAnnotationViewdidChangeDragStatefromOldState");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;
  // enum callback arg
  NSNumber* argnewState = @((NSInteger) newState);
  // enum callback arg
  NSNumber* argoldState = @((NSInteger) oldState);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewAnnotationViewdidChangeDragStatefromOldState" arguments:@{@"mapView": argmapView, @"view": argview, @"newState": argnewState, @"oldState": argoldState}];
  
}

- (MAOverlayRenderer*)mapView : (MAMapView*)mapView rendererForOverlay: (id<MAOverlay>)overlay
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewRendererForOverlay");

  // convert to jsonable arg
  

  // __block #__callback_result_type__# _callbackResult = nil;
  // [channel invokeMethod:@"#__callback_method__#"
  //             arguments:@{#__callback_args__#}
  //                result:^(id result) {
  //                  #__raw_callback_result__#
  //                }];
  //
  // while (_callbackResult == nil) {
  //   // _callbackResult有值前, 空转
  // }
  //
  // #__struct_value__#
  //
  // return #__callback_result__#;
  
  // 由于flutter无法同步调用method channel, 所以暂不支持有返回值的回调方法
  // 相关issue https://github.com/flutter/flutter/issues/28310
  NSLog(@"暂不支持有返回值的回调方法");
  
  ////////////////////////////如果需要手写代码, 请写在这里/////////////////////////////
  NSNumber* width = (NSNumber*) STACK[@"width"];
  NSNumber* strokeColor = (NSNumber*) STACK[@"strokeColor"];
  NSNumber* fillColor = (NSNumber*) STACK[@"fillColor"];

  // 线
  if ([overlay isKindOfClass:[MAPolyline class]])
  {
      MAPolylineRenderer *polylineRenderer = [[MAPolylineRenderer alloc] initWithPolyline:overlay];

      // 宽度 比android端的粗一倍 这里除以2
      polylineRenderer.lineWidth    = [width doubleValue] / 2;
      // 描边颜色
      NSUInteger rgba = [strokeColor unsignedIntegerValue];
      float components[4];
      for (int i = 3; i >= 0; i--) {
          components[i] = (rgba & 0xff) / 255.0;
          rgba >>= 8;
      }
      polylineRenderer.strokeColor  = [UIColor colorWithRed:components[1] green:components[2] blue:components[3] alpha:components[0]];

      // 这次调用完成后 清空栈
      [STACK removeAllObjects];
      return polylineRenderer;
  }

  // 多边形
  if ([overlay isKindOfClass:[MAPolygon class]])
  {
      MAPolygonRenderer *polygonRenderer = [[MAPolygonRenderer alloc] initWithPolygon:overlay];

      // 宽度 比android端的粗一倍 这里除以2
      polygonRenderer.lineWidth    = [width doubleValue] / 2;
      // 描边颜色
      NSUInteger rgba = [strokeColor unsignedIntegerValue];
      float components[4];
      for (int i = 3; i >= 0; i--) {
          components[i] = (rgba & 0xff) / 255.0;
          rgba >>= 8;
      }
      polygonRenderer.strokeColor  = [UIColor colorWithRed:components[1] green:components[2] blue:components[3] alpha:components[0]];

      // 填充颜色
      rgba = [fillColor unsignedIntegerValue];
      for (int i = 3; i >= 0; i--) {
          components[i] = (rgba & 0xff) / 255.0;
          rgba >>= 8;
      }
      polygonRenderer.fillColor  = [UIColor colorWithRed:components[1] green:components[2] blue:components[3] alpha:components[0]];

      // 这次调用完成后 清空栈
      [STACK removeAllObjects];
      return polygonRenderer;
  }

  // 圆
  if ([overlay isKindOfClass:[MACircle class]])
  {
      MACircleRenderer *circleRenderer = [[MACircleRenderer alloc] initWithCircle:overlay];

      // 宽度
      circleRenderer.lineWidth    = [width doubleValue] / 2;

      // 描边颜色
      NSUInteger rgba = [strokeColor unsignedIntegerValue];
      float components[4];
      for (int i = 3; i >= 0; i--) {
          components[i] = (rgba & 0xff) / 255.0;
          rgba >>= 8;
      }
      circleRenderer.strokeColor  = [UIColor colorWithRed:components[1] green:components[2] blue:components[3] alpha:components[0]];

      // 填充颜色
      rgba = [fillColor unsignedIntegerValue];
      for (int i = 3; i >= 0; i--) {
          components[i] = (rgba & 0xff) / 255.0;
          rgba >>= 8;
      }
      circleRenderer.fillColor  = [UIColor colorWithRed:components[1] green:components[2] blue:components[3] alpha:components[0]];

      // 这次调用完成后 清空栈
      [STACK removeAllObjects];
      return circleRenderer;
  }
  ////////////////////////////////////////////////////////////////////////////////
  
  return nil;
}

- (void)mapView : (MAMapView*)mapView didAddOverlayRenderers: (NSArray*)overlayRenderers
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidAddOverlayRenderers");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // list callback arg
  NSMutableArray<NSNumber*>* argoverlayRenderers = [NSMutableArray arrayWithCapacity:overlayRenderers.count];
  for (int i = 0; i < overlayRenderers.count; i++) {
      NSObject* item = ((NSObject*) [overlayRenderers objectAtIndex:i]);
      // return to dart side data
      argoverlayRenderers[i] = @(item.hash);
      // add to HEAP
      HEAP[@(item.hash)] = item;
  }

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidAddOverlayRenderers" arguments:@{@"mapView": argmapView, @"overlayRenderers": argoverlayRenderers}];
  
}

- (void)mapView : (MAMapView*)mapView annotationView: (MAAnnotationView*)view calloutAccessoryControlTapped: (UIControl*)control
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewAnnotationViewcalloutAccessoryControlTapped");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;
  // ref callback arg
  NSNumber* argcontrol = @(control.hash);
  HEAP[argcontrol] = control;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewAnnotationViewcalloutAccessoryControlTapped" arguments:@{@"mapView": argmapView, @"view": argview, @"control": argcontrol}];
  
}

- (void)mapView : (MAMapView*)mapView didAnnotationViewCalloutTapped: (MAAnnotationView*)view
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidAnnotationViewCalloutTapped");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidAnnotationViewCalloutTapped" arguments:@{@"mapView": argmapView, @"view": argview}];
  
}

- (void)mapView : (MAMapView*)mapView didAnnotationViewTapped: (MAAnnotationView*)view
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidAnnotationViewTapped");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argview = @(view.hash);
  HEAP[argview] = view;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidAnnotationViewTapped" arguments:@{@"mapView": argmapView, @"view": argview}];
  
}

- (void)mapView : (MAMapView*)mapView didChangeUserTrackingMode: (MAUserTrackingMode)mode animated: (BOOL)animated
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidChangeUserTrackingModeanimated");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // enum callback arg
  NSNumber* argmode = @((NSInteger) mode);
  // primitive callback arg
  NSNumber* arganimated = @(animated);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidChangeUserTrackingModeanimated" arguments:@{@"mapView": argmapView, @"mode": argmode, @"animated": arganimated}];
  
}

- (void)mapView : (MAMapView*)mapView didChangeOpenGLESDisabled: (BOOL)openGLESDisabled
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidChangeOpenGLESDisabled");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // primitive callback arg
  NSNumber* argopenGLESDisabled = @(openGLESDisabled);

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidChangeOpenGLESDisabled" arguments:@{@"mapView": argmapView, @"openGLESDisabled": argopenGLESDisabled}];
  
}

- (void)mapView : (MAMapView*)mapView didTouchPois: (NSArray*)pois
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidTouchPois");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // list callback arg
  NSMutableArray<NSNumber*>* argpois = [NSMutableArray arrayWithCapacity:pois.count];
  for (int i = 0; i < pois.count; i++) {
      NSObject* item = ((NSObject*) [pois objectAtIndex:i]);
      // return to dart side data
      argpois[i] = @(item.hash);
      // add to HEAP
      HEAP[@(item.hash)] = item;
  }

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidTouchPois" arguments:@{@"mapView": argmapView, @"pois": argpois}];
  
}

- (void)mapView : (MAMapView*)mapView didSingleTappedAtCoordinate: (CLLocationCoordinate2D*)coordinate
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidSingleTappedAtCoordinate");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // struct callback arg
  NSValue* coordinateValue = [NSValue value:&coordinate withObjCType:@encode(CLLocationCoordinate2D)];
  NSNumber* argcoordinate = @(coordinateValue.hash);
  HEAP[argcoordinate] = coordinateValue;
  

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidSingleTappedAtCoordinate" arguments:@{@"mapView": argmapView, @"coordinate": argcoordinate}];
  
}

- (void)mapView : (MAMapView*)mapView didLongPressedAtCoordinate: (CLLocationCoordinate2D*)coordinate
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidLongPressedAtCoordinate");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // struct callback arg
  NSValue* coordinateValue = [NSValue value:&coordinate withObjCType:@encode(CLLocationCoordinate2D)];
  NSNumber* argcoordinate = @(coordinateValue.hash);
  HEAP[argcoordinate] = coordinateValue;
  

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidLongPressedAtCoordinate" arguments:@{@"mapView": argmapView, @"coordinate": argcoordinate}];
  
}

- (void)mapInitComplete : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapInitComplete");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapInitComplete" arguments:@{@"mapView": argmapView}];
  
}

- (void)mapView : (MAMapView*)mapView didIndoorMapShowed: (MAIndoorInfo*)indoorInfo
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidIndoorMapShowed");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argindoorInfo = @(indoorInfo.hash);
  HEAP[argindoorInfo] = indoorInfo;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidIndoorMapShowed" arguments:@{@"mapView": argmapView, @"indoorInfo": argindoorInfo}];
  
}

- (void)mapView : (MAMapView*)mapView didIndoorMapFloorIndexChanged: (MAIndoorInfo*)indoorInfo
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidIndoorMapFloorIndexChanged");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argindoorInfo = @(indoorInfo.hash);
  HEAP[argindoorInfo] = indoorInfo;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidIndoorMapFloorIndexChanged" arguments:@{@"mapView": argmapView, @"indoorInfo": argindoorInfo}];
  
}

- (void)mapView : (MAMapView*)mapView didIndoorMapHidden: (MAIndoorInfo*)indoorInfo
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::mapViewDidIndoorMapHidden");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;
  // ref callback arg
  NSNumber* argindoorInfo = @(indoorInfo.hash);
  HEAP[argindoorInfo] = indoorInfo;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::mapViewDidIndoorMapHidden" arguments:@{@"mapView": argmapView, @"indoorInfo": argindoorInfo}];
  
}

- (void)offlineDataWillReload : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::offlineDataWillReload");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::offlineDataWillReload" arguments:@{@"mapView": argmapView}];
  
}

- (void)offlineDataDidReload : (MAMapView*)mapView
{
  FlutterMethodChannel *channel = [FlutterMethodChannel
      methodChannelWithName:@"MAMapViewDelegate::Callback"
            binaryMessenger:[_registrar messenger]];

  NSLog(@"MAMapViewDelegate::offlineDataDidReload");

  // convert to jsonable arg
  // ref callback arg
  NSNumber* argmapView = @(mapView.hash);
  HEAP[argmapView] = mapView;

  [channel invokeMethod:@"Callback::MAMapViewDelegate::offlineDataDidReload" arguments:@{@"mapView": argmapView}];
  
}

//endregion

@end
